| GlsMap Toolkit 1.10.2

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
disti::GlsMapSymbologyBasicDataSource< IconT, PathT > Class Template Reference
Inheritance diagram for disti::GlsMapSymbologyBasicDataSource< IconT, PathT >:

## Public Member Functions
void | GetSymbolsInRegion (GlsMapSymbology *symbology, const GeoRect &region, IconIDList &icons, PathIDList &paths) DISTI_METHOD_OVERRIDE
DisplayObject * | GetIconGeometry (IconID iconID, GlsMapSymbology *symbology) DISTI_METHOD_OVERRIDE
void | GetIconLocation (IconID iconID, GeoCoord &location) DISTI_METHOD_OVERRIDE
DisplayObject * | GetPathGeometry (PathID pathID, GlsMapSymbology *symbology) DISTI_METHOD_OVERRIDE
long | GetPathPointCount (PathID pathID) DISTI_METHOD_OVERRIDE
void | GetPathPointLocation (PathID pathID, long point, GeoCoord &locationOut) DISTI_METHOD_OVERRIDE
void | SetupIconForRendering (GlsMapSymbology *, IconID iconID, DisplayObject *iconGeometry) DISTI_METHOD_OVERRIDE
void | SetupPathForRendering (GlsMapSymbology *, PathID pathID, DisplayObject *iconGeometry) DISTI_METHOD_OVERRIDE
void | PostDraw (disti::GlsMapView *view, disti::GlsMapSymbology *symbology) DISTI_METHOD_OVERRIDE
virtual bool | IconIsVisible (IconT *icon)
virtual bool | PathIsVisible (PathT *path)
virtual IconID | AddIcon (const GeoCoord &location, int geometryIndex)
virtual IconT * | GetIcon (IconID iconID)
virtual unsigned int | GetIconCount ()
virtual void | UpdateIcon (IconID iconID, GeoCoord &location)
virtual void | UpdateIcon (IconID iconID, GeoCoord &location, int geometryIndex)
virtual PathID | AddPath ()
virtual PathT * | GetPath (PathID pathID)
virtual unsigned int | GetPathCount ()
virtual void | RemoveIcon (IconID iconID)
virtual void | RemovePath (PathID pathID)
virtual void | RemoveAllIcons ()
virtual void | RemoveAllPaths ()
Public Member Functions inherited from disti::GlsMapSymbologyDataSource
| GlsMapSymbologyDataSource ()
virtual | ~GlsMapSymbologyDataSource ()
virtual void | GetSymbolsInRegion (disti::GlsMapSymbology *symbology, const disti::GeoRect &region, IconIDList &icons, PathIDList &paths)=0
virtual disti::DisplayObject * | GetIconGeometry (IconID iconID, disti::GlsMapSymbology *symbology)=0
virtual void | GetIconLocation (IconID iconID, disti::GeoCoord &locationOut)=0
virtual disti::DisplayObject * | GetPathGeometry (PathID pathID, disti::GlsMapSymbology *symbology)=0
virtual long | GetPathPointCount (PathID pathID)=0
virtual void | GetPathPointLocation (PathID pathID, long pointNum, disti::GeoCoord &locationOut)=0
virtual void | SetupIconForRendering (disti::GlsMapSymbology *symbology, IconID iconID, disti::DisplayObject *iconGeometry)=0
virtual void | SetupPathForRendering (disti::GlsMapSymbology *symbology, PathID pathID, disti::DisplayObject *pathGeometry)=0
virtual void | PostDraw (disti::GlsMapView *view, disti::GlsMapSymbology *symbology)=0

## Protected Member Functions
IconID | GetNextIconID ()
int | FindIconByID (IconID id)
PathID | GetNextPathID ()
int | FindPathByID (PathID id)

## Protected Attributes
DynamicArray< IconT, false > | _iconArray
DynamicArray< IconID > | _iconIDArray
IconID | _nextIconID
DynamicArray< PathT, false > | _pathArray
DynamicArray< PathID > | _pathIDArray
PathID | _nextPathID

## Additional Inherited Members
Public Types inherited from disti::GlsMapSymbologyDataSource
typedef long | IconID
typedef long | PathID
typedef DynamicArray< IconID > | IconIDList
typedef DynamicArray< PathID > | PathIDList

## Member Function Documentation

## ◆ AddIcon()

template<class IconT , class PathT >

virtual IconID disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::AddIcon | ( | const GeoCoord & | location,
|  | int | geometryIndex
| ) |  |
| inline virtual

Add an icon to the data source

Parameters

  location | The location of the new icon
  geometryIndex | The geometry index to use for drawing. (-1 indicates do not draw)

Returns
  the IconID for the new icon

## ◆ AddPath()

template<class IconT , class PathT >

virtual PathID disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::AddPath | ( |  | ) |
| inline virtual

Add a path to the data source Call GetPath() with the returned PathID to access the new path and add/modify points in the path.

See also
  GetPath

Returns
  the PathID of the new path

## ◆ GetIcon()

template<class IconT , class PathT >

virtual IconT * disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::GetIcon | ( | IconID | iconID | ) |
| inline virtual

Access an icon in the data source

Parameters

  iconID | IconID of the desired icon

Returns
  Pointer to the given icon, or NULL if not found

## ◆ GetIconCount()

template<class IconT , class PathT >

virtual unsigned int disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::GetIconCount | ( |  | ) |
| inline virtual

Returns
  The number of icons in the data source

## ◆ GetIconGeometry()

template<class IconT , class PathT >

DisplayObject * disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::GetIconGeometry | ( | IconID | iconID,
|  | GlsMapSymbology * | symbology
| ) |  |
| inline virtual

See base class.

Implements disti::GlsMapSymbologyDataSource.

## ◆ GetIconLocation()

template<class IconT , class PathT >

void disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::GetIconLocation | ( | IconID | iconID,
|  | GeoCoord & | location
| ) |  |
| inline virtual

See base class.

Implements disti::GlsMapSymbologyDataSource.

## ◆ GetPath()

template<class IconT , class PathT >

virtual PathT * disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::GetPath | ( | PathID | pathID | ) |
| inline virtual

Access a path in the data source

Parameters

  pathID | PathID of the desired path

Returns
  Pointer to the given path, or NULL if not found

## ◆ GetPathCount()

template<class IconT , class PathT >

virtual unsigned int disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::GetPathCount | ( |  | ) |
| inline virtual

Returns
  The number of paths in the data source

## ◆ GetPathGeometry()

template<class IconT , class PathT >

DisplayObject * disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::GetPathGeometry | ( | PathID | pathID,
|  | GlsMapSymbology * | symbology
| ) |  |
| inline virtual

See base class.

Implements disti::GlsMapSymbologyDataSource.

## ◆ GetPathPointCount()

template<class IconT , class PathT >

long disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::GetPathPointCount | ( | PathID | pathID | ) |
| inline virtual

See base class.

Implements disti::GlsMapSymbologyDataSource.

## ◆ GetPathPointLocation()

template<class IconT , class PathT >

void disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::GetPathPointLocation | ( | PathID | pathID,
|  | long | point,
|  | GeoCoord & | locationOut
| ) |  |
| inline virtual

See base class.

Implements disti::GlsMapSymbologyDataSource.

## ◆ GetSymbolsInRegion()

template<class IconT , class PathT >

void disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::GetSymbolsInRegion | ( | GlsMapSymbology * | symbology,
|  | const GeoRect & | region,
|  | IconIDList & | icons,
|  | PathIDList & | paths
| ) |  |
| inline virtual

See base class.

Implements disti::GlsMapSymbologyDataSource.

## ◆ IconIsVisible()

template<class IconT , class PathT >

virtual bool disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::IconIsVisible | ( | IconT * | icon | ) |
| inline virtual

Derived classes can override this method to disable drawing of certain icon types.

## ◆ PathIsVisible()

template<class IconT , class PathT >

virtual bool disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::PathIsVisible | ( | PathT * | path | ) |
| inline virtual

Derived classes can override this method to disable drawing of certain path types.

## ◆ PostDraw()

template<class IconT , class PathT >

void disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::PostDraw | ( | disti::GlsMapView * | view,
|  | disti::GlsMapSymbology * | symbology
| ) |  |
| inline virtual

See base class.

Implements disti::GlsMapSymbologyDataSource.

## ◆ UpdateIcon() [1/2]

template<class IconT , class PathT >

virtual void disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::UpdateIcon | ( | IconID | iconID,
|  | GeoCoord & | location
| ) |  |
| inline virtual

Updates the given icon if it exists

Parameters

  iconID | The identifier of the icon to update
  location | The new location of the icon

## ◆ UpdateIcon() [2/2]

template<class IconT , class PathT >

virtual void disti::GlsMapSymbologyBasicDataSource< IconT, PathT >::UpdateIcon | ( | IconID | iconID,
|  | GeoCoord & | location,
|  | int | geometryIndex
| ) |  |
| inline virtual

Updates the given icon if it exists

Parameters

  iconID | The identifier of the icon to update
  location | The new location of the icon
  geometryIndex | The geometry index to use for drawing.

The documentation for this class was generated from the following file:

- gls_map_symbology_basic_data_source.h